=== modified file 'NEWS'
--- NEWS	2006-05-08 03:48:39 +0000
+++ NEWS	2006-05-09 07:09:48 +0000
@@ -1,3 +1,13 @@
+IN DEVELOPMENT
+
+  IMPROVEMENTS:
+
+   * On Unix, detect terminal width using an ioctl not just $COLUMNS.
+     Use terminal width for single-line logs from ``bzr log --line`` and
+     pending-merge display.  (Robert Widhopf-Fenk, Gustavo Niemeyer)
+     (Malone #3507)
+
+
 bzr 0.8  2006-05-08
 
   NOTES WHEN UPGRADING:

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2006-03-28 14:29:13 +0000
+++ bzrlib/log.py	2006-05-09 07:09:48 +0000
@@ -443,7 +443,8 @@
             return rev.message
 
     def show(self, revno, rev, delta):
-        print >> self.to_file, self.log_string(rev, 79) 
+        from bzrlib.osutils import terminal_width
+        print >> self.to_file, self.log_string(rev, terminal_width() - 1) 
 
     def log_string(self, rev, max_chars):
         out = [self.truncate(self.short_committer(rev), 20)]

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2006-05-05 01:15:53 +0000
+++ bzrlib/osutils.py	2006-05-09 07:09:48 +0000
@@ -673,10 +673,25 @@
     # TODO: Is there anything that gets a better update when the window
     # is resized while the program is running? We could use the Python termcap
     # library.
+
+    width = 0
+    
     try:
-        return int(os.environ['COLUMNS'])
-    except (IndexError, KeyError, ValueError):
-        return 80
+        import struct, fcntl, termios
+        s = struct.pack('HHHH', 0, 0, 0, 0)
+        x = fcntl.ioctl(1, termios.TIOCGWINSZ, s)
+        width = struct.unpack('HHHH', x)[1]
+    except IOError:
+        pass
+    if width <= 0:
+        try:
+            width = int(os.environ['COLUMNS'])
+        except:
+            pass
+    if width <= 0:
+        width = 80
+
+    return width
 
 def supports_executable():
     return sys.platform != "win32"

